#include <algorithm>
#include "ppn.h"
 
vector<string> str2ppn::convert( const string& txt ) {
   instr = new char[ txt.length() ];
   char  *p = instr;
   for( char c : txt )                  // пропуск разделяющих пробелов
      if( !isblank( c ) ) *p++ = c;
   *p = '\0';
   outstr.clear();
   iin = 0; 
   next();
   try {
      begin();
      if( curc != '\0' ) 
         throw syn_exception( err_msg( "лишний символ" ) );
   }
   catch(...) { throw; }  
   delete instr;
   return outstr;
}

void str2ppn::begin( void ) {           // сравнения операции (приоритет < +,-)
   try {
      add_sub(); 
      while( curc == '<' || curc == '>' ) { 
         char temp = curc;
         next();
         add_sub(); // mult_div();
         string opr;
         opr.push_back( temp );
         outstr.push_back( opr );
      }
   }
   catch(...) { throw; }
}

void str2ppn::add_sub( void ) {         // адитивные операции +, -
   try {
      mult_div();
      while( curc == '+' || curc == '-' ) { 
         char temp = curc;
         next();
         mult_div();
         string opr;
         opr.push_back( temp );
         outstr.push_back( opr );
      }
   }
   catch(...) { throw; }
}

void str2ppn::mult_div( void ) {        // мультипликативные (приоритет > адитивных)
   try {
      power(); 
      while( curc == '*' || curc == '/' ) {
         char temp = curc;
         next();
         power(); 
         string opr;
         opr.push_back( temp );
         outstr.push_back( opr );
      }
   }
   catch(...) { throw; }
}

void str2ppn::power( void ) {           // степень (приоритет > мультипликативных)
   try {
      symbol(); 
      while( curc == '^' ) {
         char temp = curc;
         next();
         symbol();
         string opr;
         opr.push_back( temp );
         outstr.push_back( opr );
      }
   }
   catch(...) { throw; }
}

void str2ppn::symbol( void ) {          // операнды и скобки 
   try {
      if( curc == '(' ) {
         next();
         begin();
         if( curc != ')' ) 
            throw syn_exception( err_msg( "баланс скобок (...)" ) );
         else next();
      }
      else if( isalnum( curc ) ) {      // операнд данных
         string opd;
         while( isalnum( curc ) ) {
            opd.push_back( curc );
            next();
         };
         outstr.push_back( opd );
      }
      else 
         throw syn_exception( err_msg( "непонятный символ" ) );
   }
   catch(...) { throw; }
}
