#ifndef PSN_H
#define PSN_H
#include <cstring> 
#include <vector>
#include <iostream>
#include "errors.h"
using namespace std;

class str2ppn {                                    // преобразование выражения в обратную польскую запись
   char *instr;                                    // входное выражение (скобочное)
   char curc;                                      // текущий обрабатываемый символ
   unsigned iin;                                   // индекс следующего к обработке символа
   void begin( void ); 
   void add_sub( void );
   void mult_div( void ); 
   void power( void );
   void symbol( void ); 
   inline void next( void ) {                      // перемещение следующий символ
      curc = ( iin < strlen( instr ) ? instr[ iin++ ] : '\0' );
   }
   string err_msg( const string& msg ) {
      string err = "синтаксис - " + msg + " :\n" + instr + '\n';
      for( unsigned i = 1; i < iin; i++ ) err.push_back( ' ' ); 
      return err + '^';
   }
public:
   const string info( void ) { return "метод рекурсивного спуска"; }
   vector<string> outstr;                          // результат - обратная польская запись
   vector<string> convert( const string& txt );    // преобразование в обратную польскую запись
   inline friend ostream& operator <<( ostream& out, const str2ppn& p ) {
      for( auto s : p.outstr ) out << s << ' ';
      return out;
   }
};
#endif
